package com.belkast.soap;

import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVRecord;

import java.io.File;
import java.io.FileReader;
import java.io.Reader;
import java.util.*;

public class userVerify
{
    public static void main (String[] args) {
        System.out.println();
        Scanner myObj = new Scanner(System.in);  // Create a Scanner object

        String varFileName = new String();
        while (true) {
            System.out.print("Enter the name of the file to verify : ");
            varFileName = myObj.nextLine();  // Read user input
            File thisFile = new File(varFileName);
            if (thisFile.exists())
            {
                break;
            }
        }

        System.out.println();
        System.out.println("CSV input file  : " + varFileName);
        ArrayList thisCSV = readCSV(varFileName, true);
        System.out.println();

        Iterator<Map> mapper1 = thisCSV.iterator();
        int varIter = 0;
        while (mapper1.hasNext())
        {
            varIter++;
            Map thisMap = mapper1.next();
            Iterator<Map.Entry<Integer, Integer>> it = thisMap.entrySet().iterator();
            while (it.hasNext())
            {
                Map.Entry<Integer, Integer> pair = it.next();
                System.out.println("record " + varIter + " key : " + pair.getKey());
                System.out.println("record " + varIter + " val : " + pair.getValue());
            }
            System.out.println();
        }
        boolean validfile = (!thisCSV.isEmpty());
        System.out.println("CSV file records  : " + varIter);
        System.out.println("CSV file is valid : " + validfile);
        System.out.println();
    }

        public static ArrayList readCSV (String thisFile, boolean fromUser)
        {
            int readNum = 0;
            int invalidNum = 0;
            ArrayList finalArray = new ArrayList();
            File varFile = new File (thisFile);
            if (!varFile.exists()) {
                System.out.println(varFile + " does not exist. Please enter a valid filename!");
                System.exit(0);
            }

            try {
                Reader in = new FileReader(varFile);
                String varHeader = fileProcessor.readFirstLine(thisFile);

                if (varHeader.length() == 0)
                {
                    System.out.println(thisFile + " : appears to be missing a valid header!");
                    return finalArray;
                }

                CSVFormat csvFormat = CSVFormat.RFC4180.builder()
                        .setHeader(varHeader.split(","))
                        .setSkipHeaderRecord(true)
                        .setIgnoreEmptyLines(true)
                        .setIgnoreSurroundingSpaces(true)
                        .setTrim(true)
                        .build();

                int headerLen = csvFormat.getHeader().length;
                Iterable<CSVRecord> records = csvFormat.parse(in);

                if (fromUser)
                {
                    System.out.println("CSV token count : " + headerLen);
                    System.out.println("CSV token list  : " + varHeader);
                    System.out.println();
                }

                for (CSVRecord record : records)
                {
                    readNum++;
                    long lineNum = record.getParser().getCurrentLineNumber();
                    boolean isValid = record.isConsistent();

                    if (isValid) {
                        finalArray.add(record.toMap());
                        if (fromUser)
                        {
                            System.out.println("PASSED : CSV line " + lineNum);
                        }
                    }
                    else
                    {
                        invalidNum++;
                        if (fromUser)
                        {
                            System.out.println("FAILED : CSV line " + lineNum);
                            System.out.println("FAILED : Contents " + record.toMap().toString());
                        }
                    }
                }
            } catch (Exception e) {
            }

            if (fromUser)
            {
                System.out.println();
                System.out.println("CSV lines passed : " + String.valueOf(readNum - invalidNum));
                System.out.println("CSV lines failed : " + invalidNum);
            }

            if (invalidNum > 0)
            {
                finalArray = new ArrayList();
            }

            return finalArray;
        }
}
